{
  First start a webserver:  command prompt
  C:\Pas2JS_206\pas2js-windows-2.0.6\bin\i386-win32\compileserver.exe -n -p 3000 -s -d "D:\MattiasChamelon_Black_White"

  Then open this page in a browser:
  http://127.0.0.1:3000/ChameleonBlackWhite1.html
}

// How to run the project ??
// where do i store the shipping .png in wordpress?
program ChameleonBlackWhite1;

{$mode objfpc}
{$ModeSwitch externalclass}

uses
  JS, Classes, SysUtils, Web, Types;

const
  LocalStorageHistoryName = 'FloodFillHistory';
  WhiteMin = 230;
  AlphaMin = 254;

type    // why two sections?
  TJSCPChangeEvent = reference to procedure;  //??    anonymous method

  TJSColorPicker = class external name 'JSColor'
  public
    constructor New(Input: TJSHTMLInputElement);
    OnChange: TJSCPChangeEvent; external name 'onChange';
    function toHexString: string; external name 'toHEXString';
    procedure fromRGBA(r, g, b, a: byte);
  end;

  TFloodFillHistoryItem = class
  public
    x,y: NativeInt;
    Color: string; // hex value
  end;
  TFloodFillHistoryItems = array of TFloodFillHistoryItem;

function RGBToHexValue(r, g, b: byte): string;    // rgb to hex for colour
begin
  Result:='#'+HexStr(r,2)+HexStr(g,2)+HexStr(b,2);
end;

procedure HexValueToRGB(Value: string; out Red, Green, Blue: byte);
begin
  Red:=parseInt(copy(value,2,2),16);
  Green:=parseInt(copy(value,4,2),16);
  Blue:=parseInt(copy(value,6,2),16);
end;

type    // why two sections?

  { TChameleonApp }

  TChameleonApp = class
  private
    img: TJSHTMLImageElement;
    Canvas: TJSHTMLCanvasElement;
    ctx: TJSCanvasRenderingContext2D;
    ColorPickerInput: TJSHTMLInputElement;
    Picker: TJSColorPicker;
    ResetButton, ConfirmResetButton: TJSHTMLButtonElement;
    History: TFloodFillHistoryItems;
    OrigPixel: TJSImageData;
    OrigData: TJSUint8ClampedArray;
    function OnCanvasClick(Event: TEventListenerEvent): boolean;
    function OnConfirmResetClick(Event: TEventListenerEvent): boolean;
    function OnLoad(Event: TEventListenerEvent): boolean;
    procedure OnPickerChange;
    function OnResetClick(Event: TEventListenerEvent): boolean;
    function ClickChameleon(Event: TJSMouseEvent): boolean;
    function FloodFill(CurData: TJSUint8ClampedArray; w,h,x,y: NativeInt; NewRed,NewGreen,NewBlue: byte): boolean;
    procedure ShowHidePopup(ElName: string; px, py: integer; Show: boolean);
    procedure ShowPopupHideOther(ElName: string; px, py: integer);
    function GetPopupAt(px, py: integer): string;
    procedure AddHistoryItem(x,y: NativeInt; NewRed,NewGreen,NewBlue: byte);
    procedure SaveHistory;
    function LoadHistory: TFloodFillHistoryItems;
    procedure ApplyHistory;
    procedure DrawImage;
  public
    procedure InitChameleon;
  end;

function TChameleonApp.OnLoad(Event: TEventListenerEvent): boolean;   // does order of methods matter ?
var
  r: TJSDOMRect;
  w, h: NativeInt;
begin
  Result:=true;
  DrawImage;
  img.style.setProperty('display','none');
  if Event=nil then ;

  r:=Canvas.getBoundingClientRect;      // how does this work?
  w:=round(r.width);
  h:=round(r.height);
  OrigPixel:=ctx.getImageData(0,0,w,h);
  OrigData:=OrigPixel.data;

  // load history
  History:=LoadHistory;
  ApplyHistory;
end;

procedure TChameleonApp.ShowHidePopup(ElName: string; px, py: integer; Show: boolean);
var
  El: TJSHTMLElement;        // eyeurl,leftbottomeyeurl,tailurl    in javascript : line 1777
begin
  El:=TJSHTMLElement(document.getElementById(ElName));
  if Show then
  begin
    El.style.setProperty('left',IntToStr(px)+'px'); // move element
    El.style.setProperty('top',IntToStr(py)+'px');
    El.style.removeProperty('display');  // show element
  end
  else
    El.style.setProperty('display','none'); // hide element
end;

procedure TChameleonApp.ShowPopupHideOther(ElName: string; px, py: integer);

  procedure ShowHide(CurElName: string);
  begin
    ShowHidePopup(CurElName,px,py,ElName=CurElName);
  end;

begin
  ShowHide('eyeurl');
  ShowHide('leftbottomeyeurl');
  ShowHide('tailurl');
end;

function TChameleonApp.GetPopupAt(px, py: integer): string;
begin
  if (px>325) and (py>180) and (px<346) and (py<206) then
    exit('eyeurl');
  if (px>300) and (py>196) and (px<337) and (py<225) then
    exit('leftbottomeyeurl');
  if (px>1060) and (py>570) and (px<1200) and (py<700) then
    exit('tailurl');
  writeln('GetPopupAt Mouse=',px,',',py);
end;
////////////////////////////////// HISTORY ////////////////////////////////////
procedure TChameleonApp.AddHistoryItem(x, y: NativeInt; NewRed, NewGreen,
  NewBlue: byte);
var
  Item: TFloodFillHistoryItem;
begin
  Item:=TFloodFillHistoryItem.Create;
  Item.x:=x;
  Item.y:=y;
  Item.Color:=RGBToHexValue(NewRed,NewGreen,NewBlue);
  TJSArray(History).push(Item);
  SaveHistory;
end;

procedure TChameleonApp.SaveHistory;
var
  s: String;
  i: Integer;
  Item: TFloodFillHistoryItem;
begin
  // store as json
  s:='[';
  for i:=0 to length(History)-1 do
  begin
    Item:=History[i];
    s:=s+'{"x":"'+str(Item.x)+'","y":"'+str(Item.y)+'","c":"'+Item.Color+'"}';
    if i<length(History)-1 then s:=s+',';
  end;
  s:=s+']';
  writeln('SaveHistory ',s);
  Window.localStorage.setItem(LocalStorageHistoryName,s);
end;

function TChameleonApp.LoadHistory: TFloodFillHistoryItems;
var
  json: String;
  Arr: TJSArray;
  i: Integer;
  Obj: TJSObject;
  Item: TFloodFillHistoryItem;
begin
  Result:=nil;
  json:=Window.localStorage.getItem(LocalStorageHistoryName);
  if (not hasValue(json)) or (json='') then exit;
  writeln('LoadHistory json=',json);
  try              Then open this page in a browser:
    Arr:=TJSArray(TJSJSON.parse(json));
  except
    writeln('LoadHistory json=',json);
    writeln('LoadHistory json parse error: ',JSExceptValue);
    exit(nil);
  end;
  writeln('LoadHistory arr=',Arr.length);
  SetLength(Result,Arr.length);
  for i:=0 to Arr.Length-1 do
  begin
    Obj:=TJSObject(Arr[i]);
    Item:=TFloodFillHistoryItem.Create;
    Item.x:=NativeInt(Obj['x']);
    Item.y:=NativeInt(Obj['y']);
    Item.Color:=String(Obj['c']);
    Result[i]:=Item;
  end;
end;

procedure TChameleonApp.ApplyHistory;
var
  r: TJSDOMRect;
  Item: TFloodFillHistoryItem;
  w, h: NativeInt;
  pixel: TJSImageData;
  Data: TJSUint8ClampedArray;
  Red, Green, Blue: byte;
  i: Integer;
begin
  r:=Canvas.getBoundingClientRect;
  w:=round(r.width);
  h:=round(r.height);
  pixel:=ctx.getImageData(0,0,w,h);
  Data:=pixel.data;

  for i:=0 to length(History)-1 do
  begin
    Item:=History[i];
    HexValueToRGB(Item.Color,Red,Green,Blue);
    FloodFill(Data,w,h,Item.x,Item.y,Red,Green,Blue);
  end;

  ctx.putImageData(pixel,0,0);
end;
////////////////////////////////////////////////////////////////////////////////
procedure TChameleonApp.DrawImage;
begin
  ctx.drawImage(img,0,0,1520,752);
end;

function TChameleonApp.ClickChameleon(Event: TJSMouseEvent): boolean;
var
  ex, ey: Double;
  pixel: TJSImageData;
  Data: TJSUint8ClampedArray;
  value: string;
  r: TJSDOMRect;
  x, y, w, h: NativeInt;
  NewRed, NewGreen, NewBlue: Byte;
begin
  Result:=true;
  r:=Canvas.getBoundingClientRect;
  w:=round(r.width);
  h:=round(r.height);
  ex:=Event.clientX - r.left;
  ey:=Event.clientY - r.top;
  x:=round(ex);
  y:=round(ey);

  pixel:=ctx.getImageData(0,0,w,h);
  Data:=pixel.data;

  // flood fill
  value:=Picker.toHexString;
  Writeln('picked color: '+value);
  HexValueToRGB(value,NewRed,NewGreen,NewBlue);

  if FloodFill(Data,w,h,x,y,NewRed,NewGreen,NewBlue) then
  begin
    AddHistoryItem(x,y,NewRed,NewGreen,NewBlue);
    ctx.putImageData(pixel,0,0);
  end;

  ShowPopupHideOther(GetPopupAt(x,y),round(Event.clientX)+20,round(Event.clientY));
end;

function TChameleonApp.FloodFill(CurData: TJSUint8ClampedArray; w, h, x,
  y: NativeInt; NewRed, NewGreen, NewBlue: byte): boolean;
var
  p: NativeInt;
  OldRed, OldGreen, OldBlue, OldAlpha: Byte;
  PxStack: TNativeIntDynArray;

  procedure Check(ax,ay: NativeInt);
  var
    ap: NativeInt;
  begin
    if (ax<0) or (ay<0) or (ax>=w) or (ay>=h) then
      exit; // outside Canvas
    ap:=(ax+ay*w)*4; // series of rows, each pixel as red, green, blue, alpha bytes.
    //writeln('Check ',ax,',',ay,' ',CurData[ap+0],',',CurData[ap+1],',',CurData[ap+2],',',CurData[ap+3]);
    if (OrigData[ap+0]<WhiteMin) or (OrigData[ap+1]<WhiteMin) or (OrigData[ap+2]<WhiteMin) or (OrigData[ap+3]<AlphaMin) then
      exit; // not a white, opaque pixel
    if (CurData[ap+0]=NewRed) and (CurData[ap+1]=NewGreen) and (CurData[ap+2]=NewBlue) then
      exit; // already colored
    CurData[ap+0]:=NewRed;
    CurData[ap+1]:=NewGreen;
    CurData[ap+2]:=NewBlue;
    TJSArray(PxStack).push(ap);
  end;

begin
  Result:=false;
  if (x>=w) or (y>=h) then exit;
  if OrigData=nil then exit;
  p:=(x+y*w)*4;
  OldRed:=OrigData[p];
  OldGreen:=OrigData[p+1];
  OldBlue:=OrigData[p+2];
  OldAlpha:=OrigData[p+3];
  writeln('TChameleonApp.FloodFill ',x,',',y,' rgba=',OldRed,',',OldGreen,',',OldBlue,',',OldAlpha);

  Check(x,y);
  while length(PxStack)>0 do
  begin
    Result:=true;
    p:=NativeInt(TJSArray(PxStack).pop) div 4;
    x:=p mod w;
    y:=p div w;
    Check(x,y-1);
    Check(x,y+1);
    Check(x-1,y);
    Check(x+1,y);
  end;
end;

function TChameleonApp.OnCanvasClick(Event: TEventListenerEvent): boolean;
begin
  ConfirmResetButton.style.setProperty('display','none');
  Result:=ClickChameleon(TJSMouseEvent(Event));
end;

function TChameleonApp.OnResetClick(Event: TEventListenerEvent): boolean;
begin
  Result:=true;
  ConfirmResetButton.style.removeProperty('display');
  if Event=nil then ;
end;

function TChameleonApp.OnConfirmResetClick(Event: TEventListenerEvent): boolean;
begin
  Result:=true;
  ConfirmResetButton.style.setProperty('display','none');

  DrawImage;
  SetLength(History,0);

  if Event=nil then ;
  SaveHistory;
end;

procedure TChameleonApp.OnPickerChange;
var
  value: String;
begin
  ConfirmResetButton.style.setProperty('display','none');

  value:=Picker.toHexString;
  Writeln('picked color: '+value);
end;

procedure TChameleonApp.InitChameleon;
var
  imgdiv: TJSHTMLElement;
  i: Integer;
begin
  img:=nil;
  imgdiv:=TJSHTMLElement(document.getElementById('originalimage'));
  for i:=0 to imgdiv.children.length-1 do
    if imgdiv.children.item(i) is TJSHTMLImageElement then
      img:=TJSHTMLImageElement(imgdiv.children.item(i));
  if img=nil then
  begin
    writeln('InitChameleon img not found');
    exit;
  end;
  Canvas:=TJSHTMLCanvasElement(document.getElementById('canvas'));
  ctx:=Canvas.getContextAs2DContext('2d');
  ColorPickerInput:=TJSHTMLInputElement(document.getElementById('colorpicker'));
  ResetButton:=TJSHTMLButtonElement(document.getElementById('resetbutton'));
  ResetButton.addEventListener('click',@OnResetClick);
  ConfirmResetButton:=TJSHTMLButtonElement(document.getElementById('confirmresetbutton'));
  ConfirmResetButton.addEventListener('click',@OnConfirmResetClick);

  Canvas.addEventListener('click',@OnCanvasClick);

  Picker:=TJSColorPicker.New(ColorPickerInput);
  Picker.OnChange:=@OnPickerChange;
  Picker.fromRGBA(0,200,0,255);
  ColorPickerInput.value:=RGBToHexValue(0,200,0);

  if not img.complete then
    img.onload:=@OnLoad
  else
    OnLoad(nil);
end;
     // how does this work?
//Main program
var
  App: TChameleonApp;
begin
  App:=TChameleonApp.Create;
  App.InitChameleon;
end.
